#ifndef H_CLIENT
#define H_CLIENT
#include <vector>
#include <thread>
#include "drone.h"

#define BUFFERSIZE 65535
bool netstatus = false;


WINDOW* wlog;
WINDOW* wform;
FORM *form;
FIELD *entries[1];

int autosock;
int roomsock;

std::thread aRecv_t;
std::thread rRecv_t;
std::thread rKeepAlive_t;

uint8_t autoserver[4] = { 209, 240, 84, 122 };
uint16_t autoport = 6650;
uint8_t roomserver[4] = { 209, 240, 84, 122 };
uint16_t roomport = 5672;

int protocol = 24;
char* version = "1000000000";
char* avatar = "avatar:pengo.mov";
int avatars = 253;
char* room = "GroundZero#Reception";
char* dimension = "dimension-1";
uint16_t roomID = 1;

char login_username[32];
char login_password[32];

uint16_t xPos = 0;
uint16_t yPos = 0;
uint16_t zPos = 0;
uint16_t rot = 0;

std::map<char, char*> properties;
std::map<char, Drone> objects;

std::vector<char*> friends;
std::vector<char*> mutes;

int deinit(int response);
static char* trim(char *str);
char* zero(int size);
unsigned char* uzero(int size);
void autoInit();
void roomInit();
void roomKeepAlive();
void reciever(int *sock, uint16_t port);
void sessInit(int *sock, char* username, char* password);
void sessExit(int *sock);
void readPropertyList(unsigned char* in);
std::map<char, char*> readOldPropertyList(unsigned char* in);
void setAvatar(int *sock, char* avatar);
void roomIDReq(int *sock, char* room);
void teleport(int *sock, int x, int y, int z, int rot);
char* dimAdd(char* room);
void userEnter(char id);
void userExit(char id);
int wsend(int *sock, unsigned char str[], int flags);

#endif